export default {
  routes: [
    {
      hidden: 0,
      rootId: 0,
      icon: 'mdi-home',
      type: 0,
      title: '工作台',
      path: '/home',
      children: [
        {
          hidden: 1,
          icon: '',
          type: 1,
          title: '工作台',
          path: '/home',
          children: [],
          enName: 'workbench',
          redirect: '',
          active: '',
          label: '工作台',
          sort: 0,
          component: 'home',
          meta: {
            keepAlive: false,
            allowClick: false,
            roles: [],
            enName: 'workbench',
            icon: '',
            editModules: true,
            title: '工作台',
            fullScreen: false,
            target: false,
            effectiveStatus: true
          },
          name: 'index',
          alwaysShow: 0
        },
        {
          hidden: 1,
          type: 1,
          title: '主页编辑',
          path: '/home/edit',
          children: [],
          enName: 'Edit Home Page',
          redirect: '',
          active: '',
          label: '主页编辑',
          sort: 0,
          component: 'home/edit',
          meta: {
            keepAlive: false,
            allowClick: false,
            roles: [],
            enName: 'Edit Home Page',
            icon: '',
            editModules: true,
            title: '主页编辑',
            fullScreen: true,
            target: false,
            effectiveStatus: true
          },
          name: 'homeEdit',
          alwaysShow: 0
        }
      ],
      enName: 'workbench',
      redirect: '',
      active: '',
      label: '工作台',
      sort: 0,
      component: 'Layout',
      meta: {
        allowClick: false,
        roles: [],
        enName: 'workbench',
        icon: 'mdi-home',
        title: '工作台',
        target: false,
        effectiveStatus: true
      },
      name: 'home',
      alwaysShow: 0
    },
    {
      meun: '',
      code: '',
      hidden: 0,
      rootId: 0,
      icon: 'mdi-database-search',
      remark: '',
      type: 0,
      title: '产品知识库',
      local: '',
      path: '/knowledge-base-product',
      urls: '',
      children: [
        {
          meun: '',
          code: '',
          hidden: 1,
          rootId: 1221,
          icon: 'mdi-file-chart-outline',
          remark: '',
          type: 1,
          title: '产品知识库列表',
          local: '',
          path: '/knowledge-base-product',
          urls: '',
          children: [],
          enName: 'product Knowledge Base',
          id: 1224,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '产品知识库列表',
          sort: 0,
          parentId: 1221,
          effectiveStatus: true,
          parentName: '',
          component: 'knowledgeBaseProduct/index',
          meta: {
            keepAlive: false,
            allowClick: false,
            roles: [],
            enName: 'product Knowledge Base',
            icon: 'mdi-file-chart-outline',
            editModules: false,
            title: '产品知识库列表',
            fullScreen: false,
            target: false,
            effectiveStatus: true
          },
          name: 'knowledgeBaseProductList',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"allowClick":false,"enName":"product Knowledge Base","editModules":false,"title":"产品知识库列表","fullScreen":false,"target":false}',
          open: null
        }
      ],
      enName: 'product Knowledge Base',
      id: 1221,
      redirect: '',
      level: 1,
      openPath: '',
      active: '',
      label: '产品知识库',
      sort: 18,
      parentId: 0,
      effectiveStatus: true,
      parentName: '',
      component: 'Layout',
      meta: {
        allowClick: false,
        roles: [],
        enName: 'product Knowledge Base',
        icon: 'mdi-database-search',
        title: '产品知识库',
        target: false,
        effectiveStatus: true
      },
      name: 'knowledgeBaseProduct',
      style: '',
      alwaysShow: 0,
      metastr: '{"allowClick":false,"enName":"product Knowledge Base","title":"产品知识库","target":false}',
      open: null
    },
    {
      hidden: 0,
      rootId: 0,
      icon: 'mdi-chart-box',
      type: 0,
      path: '/data-chart',
      children: [
        {
          hidden: 1,
          icon: '',
          type: 1,
          title: '数据图表',
          path: '/data-chart',
          children: [],
          enName: 'data Chart',
          redirect: '',
          active: '',
          label: '数据图表',
          sort: 0,
          component: 'dataChart',
          meta: {
            roles: [],
            enName: 'data Chart',
            icon: '',
            title: '数据图表',
            fullScreen: false
          },
          name: 'index',
          alwaysShow: 0
        }
      ],
      enName: 'data Chart',
      redirect: '',
      active: '',
      sort: 0,
      component: 'Layout',
      meta: {
        allowClick: false,
        roles: [],
        enName: 'workbench',
        icon: 'mdi-home',
        title: '数据图表',
        target: false,
        effectiveStatus: true
      },
      name: 'home',
      alwaysShow: 0
    },
    {
      meun: '',
      code: '',
      hidden: 0,
      rootId: 0,
      icon: 'mdi-database-clock',
      remark: '',
      type: 0,
      title: '数据资产',
      local: '',
      path: '/data-asset',
      urls: '',
      children: [
        {
          meun: '',
          code: '',
          hidden: 1,
          rootId: 1231,
          icon: '',
          remark: '',
          type: 1,
          title: '产品知识库列表',
          local: '',
          path: '/data-asset',
          urls: '',
          children: [],
          enName: 'Data Asset',
          id: 1232,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '产品知识库列表',
          sort: 0,
          parentId: 1231,
          effectiveStatus: true,
          parentName: '',
          component: 'dataAsset',
          meta: {
            keepAlive: false,
            allowClick: false,
            roles: [],
            enName: 'Data Asset',
            icon: '',
            editModules: false,
            title: '产品知识库列表',
            fullScreen: false,
            target: false,
            effectiveStatus: true
          },
          name: 'dataAssetList',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"allowClick":false,"enName":"Data Asset","editModules":false,"title":"产品知识库列表","fullScreen":false,"target":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 1,
          rootId: 1231,
          icon: '',
          remark: '',
          type: 1,
          title: '产品知识库详情',
          local: '',
          path: '/data-asset/details/:id/:name',
          urls: '',
          children: [],
          enName: 'Data Asset Details',
          id: 1233,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '产品知识库详情',
          sort: 0,
          parentId: 1231,
          effectiveStatus: true,
          parentName: '',
          component: 'dataAsset/details',
          meta: {
            keepAlive: false,
            allowClick: false,
            roles: [],
            enName: 'Data Asset Details',
            icon: '',
            editModules: false,
            title: '产品知识库详情',
            fullScreen: false,
            target: false,
            effectiveStatus: true
          },
          name: 'dataAssetDetails',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"allowClick":false,"enName":"Data Asset Details","editModules":false,"title":"产品知识库详情","fullScreen":false,"target":false}',
          open: null
        }
      ],
      enName: 'Data Asset',
      id: 1231,
      redirect: '',
      level: 1,
      openPath: '',
      active: '',
      label: '数据资产',
      sort: 30,
      parentId: 0,
      effectiveStatus: true,
      parentName: '',
      component: 'Layout',
      meta: {
        allowClick: true,
        roles: [],
        enName: 'Data Asset',
        icon: 'mdi-database-clock',
        title: '数据资产',
        target: false,
        effectiveStatus: true
      },
      name: 'dataAsset',
      style: '',
      alwaysShow: 0,
      metastr: '{"allowClick":true,"enName":"Data Asset","title":"数据资产","target":false}',
      open: null
    },
    {
      meun: '',
      code: '',
      hidden: 0,
      rootId: 0,
      icon: 'mdi-clipboard-text-outline',
      remark: '',
      type: 0,
      title: '数据治理',
      local: '',
      path: '/data-governance',
      urls: '',
      children: [
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 1187,
          icon: 'mdi-book-open-outline',
          remark: '',
          type: 1,
          title: '元数据',
          local: '',
          path: '/data-governance/metadata',
          urls: '',
          children: [],
          enName: 'Metadata',
          id: 1188,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '元数据',
          sort: 0,
          parentId: 1187,
          effectiveStatus: true,
          parentName: 'data-governance',
          component: 'dataGovernance/metadata',
          meta: {
            keepAlive: false,
            allowClick: true,
            roles: [],
            enName: 'Metadata',
            icon: 'mdi-book-open-outline',
            editModules: false,
            title: '元数据',
            fullScreen: false,
            target: false,
            effectiveStatus: true
          },
          name: 'metadata',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"allowClick":true,"enName":"Metadata","editModules":false,"title":"元数据","fullScreen":false,"target":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 1187,
          icon: 'mdi-book-open-outline',
          remark: '',
          type: 1,
          title: '数据资源',
          local: '',
          path: '/data-governance/data-resource',
          urls: '',
          children: [],
          enName: 'Data Resource',
          id: 1189,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '数据资源',
          sort: 1,
          parentId: 1187,
          effectiveStatus: true,
          parentName: 'data-governance',
          component: 'dataGovernance/dataResource',
          meta: {
            keepAlive: false,
            allowClick: false,
            roles: [],
            enName: 'Data Resource',
            icon: 'mdi-book-open-outline',
            editModules: false,
            title: '数据资源',
            fullScreen: false,
            target: false,
            effectiveStatus: true
          },
          name: 'data-resource',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"allowClick":false,"enName":"Data Resource","editModules":false,"title":"数据资源","fullScreen":false,"target":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 1187,
          icon: '',
          remark: '',
          type: 1,
          title: '数据模型',
          local: '',
          path: '/data-governance/data-modules',
          urls: '',
          children: [],
          enName: 'Data Field',
          id: 1193,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '数据模型',
          sort: 4,
          parentId: 1187,
          effectiveStatus: true,
          parentName: 'data-governance',
          component: 'dataGovernance/dataModules',
          meta: {
            keepAlive: false,
            allowClick: true,
            roles: [],
            enName: 'Data Field',
            icon: '',
            editModules: false,
            title: '数据模型',
            fullScreen: false,
            target: false,
            effectiveStatus: true
          },
          name: 'data-modules',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"allowClick":true,"enName":"Data Field","editModules":false,"title":"数据模型","fullScreen":false,"target":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 1187,
          icon: '',
          remark: '',
          type: 1,
          title: '数据指标',
          local: '',
          path: '/data-governance/data-indicator',
          urls: '',
          children: [],
          enName: 'Data Indicator',
          id: 1190,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '数据指标',
          sort: 5,
          parentId: 1187,
          effectiveStatus: true,
          parentName: 'data-governance',
          component: 'dataGovernance/dataIndicator',
          meta: {
            keepAlive: false,
            allowClick: false,
            roles: [],
            enName: 'Data Indicator',
            icon: '',
            editModules: false,
            title: '数据指标',
            fullScreen: false,
            target: false,
            effectiveStatus: true
          },
          name: 'data-indicator',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"allowClick":false,"enName":"Data Indicator","editModules":false,"title":"数据指标","fullScreen":false,"target":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 1187,
          icon: '',
          remark: '',
          type: 1,
          title: '数据标准',
          local: '',
          path: '/data-governance/data-standard',
          urls: '',
          children: [],
          enName: 'Data Standard',
          id: 1191,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '数据标准',
          sort: 10,
          parentId: 1187,
          effectiveStatus: true,
          parentName: 'data-governance',
          component: 'dataGovernance/dataStandard',
          meta: {
            keepAlive: false,
            allowClick: false,
            roles: [],
            enName: 'Data Standard',
            icon: '',
            editModules: false,
            title: '数据标准',
            fullScreen: false,
            target: false,
            effectiveStatus: true
          },
          name: 'data-standard',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"allowClick":false,"enName":"Data Standard","editModules":false,"title":"数据标准","fullScreen":false,"target":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 2000,
          icon: '',
          remark: '',
          type: 1,
          title: '数据流程',
          local: '',
          path: '/data-governance/data-process',
          urls: '',
          children: [],
          enName: 'Data Process',
          id: 1191,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '数据流程',
          sort: 10,
          parentId: 1187,
          effectiveStatus: true,
          parentName: 'data-governance',
          component: 'dataGovernance/dataProcess',
          meta: {
            keepAlive: false,
            allowClick: false,
            roles: [],
            enName: 'Data Process',
            icon: '',
            editModules: false,
            title: '数据流程',
            fullScreen: false,
            target: false,
            effectiveStatus: true
          },
          name: 'data-process',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"allowClick":false,"enName":"Data Process","editModules":false,"title":"数据流程","fullScreen":false,"target":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 1187,
          icon: '',
          remark: '',
          type: 1,
          title: '数据标签',
          local: '',
          path: '/data-governance/data-Label',
          urls: '',
          children: [],
          enName: 'Data Label',
          id: 1217,
          redirect: '',
          level: 0,
          openPath: '',
          active: '',
          label: '数据标签',
          sort: 15,
          parentId: 1187,
          effectiveStatus: true,
          parentName: '',
          component: 'dataGovernance/dataLabel',
          meta: {
            keepAlive: false,
            allowClick: false,
            roles: [],
            enName: 'Data Label',
            icon: '',
            editModules: false,
            title: '数据标签',
            fullScreen: false,
            target: false,
            effectiveStatus: true
          },
          name: 'data-label',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"allowClick":false,"enName":"Data Label","editModules":false,"title":"数据标签","fullScreen":false,"target":false}',
          open: null
        }
      ],
      enName: 'Data Governance',
      id: 1187,
      redirect: '',
      level: 1,
      openPath: '',
      active: '',
      label: '数据治理',
      sort: 44,
      parentId: 0,
      effectiveStatus: true,
      parentName: '',
      component: 'Layout',
      meta: {
        allowClick: false,
        roles: [],
        enName: 'Data Governance',
        icon: 'mdi-clipboard-text-outline',
        title: '数据治理',
        target: false,
        effectiveStatus: true
      },
      name: 'data-governance',
      style: '',
      alwaysShow: 0,
      metastr: '{"allowClick":false,"enName":"Data Governance","title":"数据治理","target":false}',
      open: null
    },
    {
      meun: '',
      code: '',
      hidden: 0,
      rootId: 0,
      icon: 'mdi-factory',
      remark: '',
      type: 0,
      title: '数据工厂',
      local: '',
      path: '/dataFactory',
      urls: '',
      children: [
        {
          meun: '',
          code: '',
          hidden: 1,
          rootId: 972,
          icon: '',
          remark: '',
          type: 1,
          title: '生产线监控',
          local: '',
          path: '/dataFactory/production-line-monitor1',
          urls: '',
          children: [],
          enName: 'production line monitor',
          id: 99999999,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '生产线监控',
          sort: 4,
          parentId: 972,
          effectiveStatus: true,
          parentName: 'dataFactory',
          component: 'dataFactory/productionLineMonitor',
          meta: {
            noLogin: true,
            keepAlive: false,
            allowClick: false,
            roles: [],
            enName: 'production line monitor',
            icon: '',
            editModules: false,
            title: '生产线监控',
            fullScreen: true,
            target: false,
            dataPermission: false,
            effectiveStatus: true
          },
          name: 'productionLineMonitor',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"noLogin":true,"allowClick":false,"enName":"production line monitor","editModules":false,"title":"生产线监控","fullScreen":true,"target":false,"dataPermission":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 972,
          icon: '',
          remark: '',
          type: 1,
          title: '生产线监控',
          local: '',
          path: '/dataFactory/production-line-monitor',
          urls: '',
          children: [],
          enName: 'production line monitor',
          id: 961,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '生产线监控',
          sort: 4,
          parentId: 972,
          effectiveStatus: true,
          parentName: 'dataFactory',
          component: 'dataFactory/productionLineMonitor',
          meta: {
            keepAlive: false,
            allowClick: false,
            roles: [],
            enName: 'production line monitor',
            icon: '',
            editModules: false,
            title: '生产线监控',
            fullScreen: false,
            target: false,
            dataPermission: false,
            effectiveStatus: true
          },
          name: 'productionLineMonitor',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"allowClick":false,"enName":"production line monitor","editModules":false,"title":"生产线监控","fullScreen":false,"target":false,"dataPermission":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 972,
          icon: '',
          remark: '',
          type: 1,
          title: '生产线管理',
          local: '',
          path: '/dataFactory/production-line-manage',
          urls: '',
          children: [],
          enName: 'Assembly Line',
          id: 973,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '生产线管理',
          sort: 6,
          parentId: 972,
          effectiveStatus: true,
          parentName: 'dataFactory',
          component: 'dataFactory/productionLine',
          meta: {
            keepAlive: false,
            allowClick: false,
            roles: [],
            enName: 'Assembly Line',
            icon: '',
            editModules: false,
            title: '生产线管理',
            fullScreen: false,
            target: false,
            effectiveStatus: true
          },
          name: 'productionLine',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"allowClick":false,"enName":"Assembly Line","editModules":false,"title":"生产线管理","fullScreen":false,"target":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 972,
          icon: '',
          remark: '',
          type: 1,
          title: '生产线调度',
          local: '',
          path: '/dataFactory/production-line-dispatch',
          urls: '',
          children: [],
          enName: 'Assembly Line',
          id: 1230,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '生产线调度',
          sort: 8,
          parentId: 972,
          effectiveStatus: true,
          parentName: '',
          component: 'dataFactory/dispatch',
          meta: {
            keepAlive: false,
            allowClick: false,
            roles: [],
            enName: 'Assembly Line',
            icon: '',
            editModules: false,
            title: '生产线调度',
            fullScreen: false,
            target: false,
            effectiveStatus: true
          },
          name: 'productionLineDispatch',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"allowClick":false,"enName":"Assembly Line","editModules":false,"title":"生产线调度","fullScreen":false,"target":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 972,
          icon: '',
          remark: '',
          type: 1,
          title: '生产线日志',
          local: '',
          path: '/dataFactory/log-manage',
          urls: '',
          children: [],
          enName: 'log manage',
          id: 974,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '生产线日志',
          sort: 10,
          parentId: 972,
          effectiveStatus: true,
          parentName: 'dataFactory',
          component: 'dataFactory/logManage',
          meta: {
            keepAlive: false,
            allowClick: false,
            roles: [],
            enName: 'log manage',
            icon: '',
            editModules: false,
            title: '生产线日志',
            fullScreen: false,
            target: false,
            effectiveStatus: true
          },
          name: 'productionLineLogManage',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"allowClick":false,"enName":"log manage","editModules":false,"title":"生产线日志","fullScreen":false,"target":false}',
          open: null
        }
      ],
      enName: 'production line manage',
      id: 972,
      redirect: '',
      level: 1,
      openPath: '',
      active: '',
      label: '数据工厂',
      sort: 46,
      parentId: 0,
      effectiveStatus: true,
      parentName: 'dataFactory',
      component: 'Layout',
      meta: {
        allowClick: false,
        roles: [],
        enName: 'production line manage',
        icon: 'mdi-factory',
        title: '数据工厂',
        target: false,
        effectiveStatus: true
      },
      name: 'dataFactory',
      style: '',
      alwaysShow: 0,
      metastr: '{"allowClick":false,"enName":"production line manage","title":"数据工厂","target":false}',
      open: null
    },
    {
      meun: '',
      code: '',
      hidden: 0,
      rootId: 0,
      icon: 'mdi-widgets-outline',
      remark: '',
      type: 0,
      title: '数据来源',
      local: '',
      path: '/data-origin',
      urls: '',
      children: [

        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 1319,
          icon: 'mdi-widgets-outline',
          remark: '',
          type: 1,
          title: 'RDBMS数据源',
          local: '',
          path: '/data-origin/rdbms',
          urls: '',
          children: [],
          enName: 'RDBMS Data Source',
          id: 1328,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: 'RDBMS数据源',
          sort: 1,
          parentId: 1319,
          effectiveStatus: true,
          parentName: '',
          component: 'dataOrigin/rdbmsDataSource',
          meta: {
            keepAlive: false,
            allowClick: false,
            roles: [],
            enName: 'RDBMS Data Source',
            icon: 'mdi-widgets-outline',
            editModules: false,
            title: 'RDBMS数据源',
            fullScreen: false,
            target: false,
            dataPermission: false,
            effectiveStatus: true
          },
          name: 'data-origin',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"allowClick":false,"enName":"RDBMS Data Source","editModules":false,"title":"RDBMS数据源","fullScreen":false,"target":false,"dataPermission":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 1319,
          icon: 'mdi-widgets-outline',
          remark: '',
          type: 1,
          title: '非结构化数据源',
          local: '',
          path: '/data-origin/unstructured',
          urls: '',
          children: [
            {
              meun: '',
              code: '',
              hidden: 0,
              rootId: 1319,
              icon: 'mdi-account-plus-outline',
              remark: '',
              type: 1,
              title: '手动收集',
              local: '',
              path: '/data-origin/unstructured/manual-collection',
              urls: '',
              children: [],
              enName: 'Manual collection',
              id: 1320,
              redirect: '',
              level: 3,
              openPath: '',
              active: '',
              label: '手动收集',
              sort: 1,
              parentId: 1327,
              effectiveStatus: true,
              parentName: '',
              component: 'dataOrigin/unstructuredData/manualCollection',
              meta: {
                keepAlive: false,
                allowClick: false,
                roles: [
                  {
                    active: '1',
                    alwaysShow: 0,
                    children: [],
                    code: '',
                    component: '',
                    effectiveStatus: true,
                    enName: 'Excel Import',
                    hidden: 0,
                    icon: '',
                    id: 1321,
                    label: 'Excel导入',
                    level: 3,
                    local: '',
                    meta: null,
                    metastr: '{"enName":"Excel Import","title":"Excel导入","target":false}',
                    meun: '',
                    name: 'excelImport',
                    open: 0,
                    openPath: '',
                    parentId: 1320,
                    parentName: '',
                    path: '',
                    redirect: '',
                    remark: '',
                    rootId: 1319,
                    sort: 0,
                    style: '',
                    type: 3,
                    urls: ''
                  },
                  {
                    active: '1',
                    alwaysShow: 0,
                    children: [],
                    code: '',
                    component: '',
                    effectiveStatus: true,
                    enName: 'Image Import',
                    hidden: 0,
                    icon: '',
                    id: 1322,
                    label: '名片解析',
                    level: 3,
                    local: '',
                    meta: null,
                    metastr: '{"enName":"Image Import","title":"名片解析","target":false}',
                    meun: '',
                    name: 'imageImport',
                    open: 0,
                    openPath: '',
                    parentId: 1320,
                    parentName: '',
                    path: '',
                    redirect: '',
                    remark: '',
                    rootId: 1319,
                    sort: 5,
                    style: '',
                    type: 3,
                    urls: ''
                  },
                  {
                    active: '1',
                    alwaysShow: 0,
                    children: [],
                    code: '',
                    component: '',
                    effectiveStatus: true,
                    enName: 'Manual Import',
                    hidden: 0,
                    icon: '',
                    id: 1323,
                    label: '手动输入',
                    level: 3,
                    local: '',
                    meta: null,
                    metastr: '{"enName":"Manual Import","title":"手动输入","target":false}',
                    meun: '',
                    name: 'manualImport',
                    open: 0,
                    openPath: '',
                    parentId: 1320,
                    parentName: '',
                    path: '',
                    redirect: '',
                    remark: '',
                    rootId: 1319,
                    sort: 10,
                    style: '',
                    type: 3,
                    urls: ''
                  }
                ],
                enName: 'Manual collection',
                icon: 'mdi-account-plus-outline',
                editModules: false,
                title: '手动收集',
                fullScreen: false,
                target: false,
                dataPermission: false,
                effectiveStatus: true
              },
              name: 'manual-collection',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":false,"enName":"Manual collection","editModules":false,"title":"手动收集","fullScreen":false,"target":false,"dataPermission":false}',
              open: null
            },
            {
              meun: '',
              code: '',
              hidden: 0,
              rootId: 1319,
              icon: 'mdi-bug',
              remark: '',
              type: 1,
              title: '自动收集',
              local: '',
              path: '/data-origin/unstructured/auto-collection',
              urls: '',
              children: [],
              enName: 'Auto collection',
              id: 1324,
              redirect: '',
              level: 3,
              openPath: '',
              active: '',
              label: '自动收集',
              sort: 1,
              parentId: 1327,
              effectiveStatus: true,
              parentName: '',
              component: 'dataOrigin/unstructuredData/autoCollection',
              meta: {
                keepAlive: false,
                allowClick: false,
                roles: [
                  {
                    active: '1',
                    alwaysShow: 0,
                    children: [],
                    code: '',
                    component: '',
                    effectiveStatus: true,
                    enName: 'Spider Management',
                    hidden: 0,
                    icon: 'mdi-bug',
                    id: 1325,
                    label: '爬虫管理',
                    level: 3,
                    local: '',
                    meta: null,
                    metastr: '{"enName":"Spider Management","title":"爬虫管理","target":false}',
                    meun: '',
                    name: 'spiderManagement',
                    open: 0,
                    openPath: '',
                    parentId: 1324,
                    parentName: '',
                    path: '',
                    redirect: '',
                    remark: '',
                    rootId: 1319,
                    sort: 1,
                    style: '',
                    type: 3,
                    urls: ''
                  },
                  {
                    active: '1',
                    alwaysShow: 0,
                    children: [],
                    code: '',
                    component: '',
                    effectiveStatus: true,
                    enName: 'Page Parsing',
                    hidden: 0,
                    icon: 'mdi-bug',
                    id: 1326,
                    label: '网页解析',
                    level: 3,
                    local: '',
                    meta: null,
                    metastr: '{"enName":"Page Parsing","title":"网页解析","target":false}',
                    meun: '',
                    name: 'pageParsing',
                    open: 0,
                    openPath: '',
                    parentId: 1324,
                    parentName: '',
                    path: '',
                    redirect: '',
                    remark: '',
                    rootId: 1319,
                    sort: 1,
                    style: '',
                    type: 3,
                    urls: ''
                  }
                ],
                enName: 'Auto collection',
                icon: 'mdi-bug',
                editModules: false,
                title: '自动收集',
                fullScreen: false,
                target: false,
                dataPermission: false,
                effectiveStatus: true
              },
              name: 'auto-collection',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":false,"enName":"Auto collection","editModules":false,"title":"自动收集","fullScreen":false,"target":false,"dataPermission":false}',
              open: null
            }
          ],
          enName: 'Unstructured Data Source',
          id: 1327,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '非结构化数据源',
          sort: 10,
          parentId: 1319,
          effectiveStatus: true,
          parentName: '',
          component: '',
          meta: {
            keepAlive: false,
            allowClick: false,
            roles: [],
            enName: 'Unstructured Data Source',
            icon: 'mdi-widgets-outline',
            editModules: false,
            title: '非结构化数据源',
            fullScreen: false,
            target: false,
            dataPermission: false,
            effectiveStatus: true
          },
          name: 'unstructured',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"allowClick":false,"enName":"Unstructured Data Source","editModules":false,"title":"非结构化数据源","fullScreen":false,"target":false,"dataPermission":false}',
          open: null
        }
      ],
      enName: 'Data collection',
      id: 1319,
      redirect: '',
      level: 1,
      openPath: '',
      active: '',
      label: '数据来源',
      sort: 47,
      parentId: 0,
      effectiveStatus: true,
      parentName: '',
      component: 'Layout',
      meta: {
        allowClick: false,
        roles: [],
        enName: 'Data collection',
        icon: 'mdi-widgets-outline',
        title: '数据来源',
        target: false,
        effectiveStatus: true
      },
      name: 'data-origin',
      style: '',
      alwaysShow: 0,
      metastr: '{"allowClick":false,"enName":"Data collection","title":"数据来源","target":false}',
      open: null
    },
    {
      meun: '',
      code: '',
      hidden: 0,
      rootId: 0,
      icon: 'mdi-book-open-outline',
      remark: '',
      type: 0,
      title: '数据目录',
      local: '',
      path: '/data-book',
      urls: '',
      children: [
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 1225,
          icon: '',
          remark: '',
          type: 0,
          title: '元数据',
          local: '',
          path: '/data-book/data-metadata',
          urls: '',
          children: [
            {
              meun: '',
              code: '',
              hidden: 1,
              rootId: 1225,
              icon: '',
              remark: '',
              type: 1,
              title: '元数据',
              local: '',
              path: '/data-book/data-metadata',
              urls: '',
              children: [],
              enName: 'metaData',
              id: 1214,
              redirect: '',
              level: 0,
              openPath: '',
              active: '',
              label: '元数据',
              sort: 0,
              parentId: 1213,
              effectiveStatus: true,
              parentName: '',
              component: 'dataBook/dataMetaData',
              meta: {
                keepAlive: false,
                allowClick: true,
                roles: [],
                enName: 'metaData',
                icon: '',
                editModules: false,
                title: '元数据',
                fullScreen: false,
                target: false,
                effectiveStatus: true
              },
              name: 'data-metadata-list',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":true,"enName":"metaData","editModules":false,"title":"元数据","fullScreen":false,"target":false}',
              open: null
            },
            {
              meun: '',
              code: '',
              hidden: 1,
              rootId: 1225,
              icon: '',
              remark: '',
              type: 1,
              title: '元数据详情',
              local: '',
              path: '/data-book/data-metadata/details/:id/:name',
              urls: '',
              children: [],
              enName: 'metaData details',
              id: 1215,
              redirect: '',
              level: 0,
              openPath: '',
              active: '',
              label: '元数据详情',
              sort: 0,
              parentId: 1213,
              effectiveStatus: true,
              parentName: '',
              component: 'dataBook/dataMetaData/details',
              meta: {
                keepAlive: false,
                allowClick: false,
                roles: [],
                enName: 'metaData details',
                icon: '',
                editModules: false,
                title: '元数据详情',
                fullScreen: false,
                target: false,
                effectiveStatus: true
              },
              name: 'data-metadata-details',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":false,"enName":"metaData details","editModules":false,"title":"元数据详情","fullScreen":false,"target":false}',
              open: null
            }
          ],
          enName: 'metadata',
          id: 1213,
          redirect: '',
          level: 0,
          openPath: '',
          active: '',
          label: '元数据',
          sort: 1,
          parentId: 1225,
          effectiveStatus: true,
          parentName: '',
          component: '',
          meta: {
            allowClick: true,
            roles: [],
            enName: 'metadata',
            icon: '',
            title: '元数据',
            target: false,
            effectiveStatus: true
          },
          name: 'data-metadata',
          style: '',
          alwaysShow: 0,
          metastr: '{"allowClick":true,"enName":"metadata","title":"元数据","target":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 1225,
          icon: '',
          remark: '',
          type: 0,
          title: '数据资源',
          local: '',
          path: '/data-book/data-resource',
          urls: '',
          children: [
            {
              meun: '',
              code: '',
              hidden: 1,
              rootId: 1225,
              icon: '',
              remark: '',
              type: 1,
              title: '数据资源详情',
              local: '',
              path: '/data-book/data-resource/details/:id/:name',
              urls: '',
              children: [],
              enName: 'data Modules Details',
              id: 1204,
              redirect: '',
              level: 3,
              openPath: '',
              active: '',
              label: '数据资源详情',
              sort: 0,
              parentId: 1207,
              effectiveStatus: true,
              parentName: '',
              component: 'dataBook/dataResource/details',
              meta: {
                keepAlive: false,
                allowClick: false,
                roles: [],
                enName: 'data Modules Details',
                icon: '',
                editModules: false,
                title: '数据资源详情',
                fullScreen: false,
                target: false,
                effectiveStatus: true
              },
              name: 'data-book-data-resource-details',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":false,"enName":"data Modules Details","editModules":false,"title":"数据资源详情","fullScreen":false,"target":false}',
              open: null
            },
            {
              meun: '',
              code: '',
              hidden: 1,
              rootId: 662,
              icon: '',
              remark: '',
              type: 1,
              title: '数据资源',
              local: '',
              path: '/data-book/data-resource',
              urls: '',
              children: [],
              enName: 'data Resource',
              id: 1208,
              redirect: '',
              level: 0,
              openPath: '',
              active: '',
              label: '数据资源',
              sort: 8,
              parentId: 1207,
              effectiveStatus: true,
              parentName: '',
              component: 'dataBook/dataResource',
              meta: {
                keepAlive: false,
                allowClick: true,
                roles: [],
                enName: 'data Resource',
                icon: '',
                editModules: false,
                title: '数据资源',
                fullScreen: false,
                target: false,
                effectiveStatus: true
              },
              name: 'dataBookDataResourceIndex',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":true,"enName":"data Resource","editModules":false,"title":"数据资源","fullScreen":false,"target":false}',
              open: null
            }
          ],
          enName: 'data Resource',
          id: 1207,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '数据资源',
          sort: 4,
          parentId: 1225,
          effectiveStatus: true,
          parentName: '',
          component: '',
          meta: {
            allowClick: true,
            roles: [],
            enName: 'data Resource',
            icon: '',
            title: '数据资源',
            target: false,
            effectiveStatus: true
          },
          name: 'data-book-resource',
          style: '',
          alwaysShow: 0,
          metastr: '{"allowClick":true,"enName":"data Resource","title":"数据资源","target":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 1225,
          icon: '',
          remark: '',
          type: 0,
          title: '数据模型',
          local: '',
          path: '/data-book/data-model',
          urls: '',
          children: [
            {
              meun: '',
              code: '',
              hidden: 1,
              rootId: 1225,
              icon: '',
              remark: '',
              type: 1,
              title: '数据模型详情',
              local: '',
              path: '/data-book/data-model/details/:id/:name',
              urls: '',
              children: [],
              enName: 'data Modules Details',
              id: 1212,
              redirect: '',
              level: 3,
              openPath: '',
              active: '',
              label: '数据模型详情',
              sort: 0,
              parentId: 1210,
              effectiveStatus: true,
              parentName: '',
              component: 'dataBook/dataModel/details',
              meta: {
                keepAlive: false,
                allowClick: false,
                roles: [],
                enName: 'data Modules Details',
                icon: '',
                editModules: false,
                title: '数据模型详情',
                fullScreen: false,
                target: false,
                effectiveStatus: true
              },
              name: 'data-book-data-model-details',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":false,"enName":"data Modules Details","editModules":false,"title":"数据模型详情","fullScreen":false,"target":false}',
              open: null
            },
            {
              meun: '',
              code: '',
              hidden: 1,
              rootId: 1225,
              icon: '',
              remark: '',
              type: 1,
              title: '数据模型',
              local: '',
              path: '/data-book/data-model',
              urls: '',
              children: [],
              enName: 'data Model',
              id: 1211,
              redirect: '',
              level: 3,
              openPath: '',
              active: '',
              label: '数据模型',
              sort: 20,
              parentId: 1210,
              effectiveStatus: true,
              parentName: '',
              component: 'dataBook/dataModel',
              meta: {
                keepAlive: false,
                allowClick: true,
                roles: [],
                enName: 'data Model',
                icon: '',
                editModules: false,
                title: '数据模型',
                fullScreen: false,
                target: false,
                effectiveStatus: true
              },
              name: 'data-book-data-model-index',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":true,"enName":"data Model","editModules":false,"title":"数据模型","fullScreen":false,"target":false}',
              open: null
            }
          ],
          enName: 'data Model',
          id: 1210,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '数据模型',
          sort: 11,
          parentId: 1225,
          effectiveStatus: true,
          parentName: '',
          component: '',
          meta: {
            allowClick: true,
            roles: [],
            enName: 'data Model',
            icon: '',
            title: '数据模型',
            target: false,
            effectiveStatus: true
          },
          name: 'data-book-data-model',
          style: '',
          alwaysShow: 0,
          metastr: '{"allowClick":true,"enName":"data Model","title":"数据模型","target":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 1225,
          icon: '',
          remark: '',
          type: 0,
          title: '数据指标',
          local: '',
          path: '/data-book/data-indicator',
          urls: '',
          children: [
            {
              meun: '',
              code: '',
              hidden: 1,
              rootId: 1225,
              icon: '',
              remark: '',
              type: 1,
              title: '数据指标',
              local: '',
              path: '/data-book/data-indicator',
              urls: '',
              children: [],
              enName: 'data Indicator',
              id: 1267,
              redirect: '',
              level: 3,
              openPath: '',
              active: '',
              label: '数据指标',
              sort: 1,
              parentId: 1182,
              effectiveStatus: true,
              parentName: '',
              component: 'dataBook/indicator',
              meta: {
                keepAlive: false,
                allowClick: true,
                roles: [],
                enName: 'data Indicator',
                icon: '',
                editModules: false,
                title: '数据指标',
                fullScreen: false,
                target: false,
                effectiveStatus: true
              },
              name: 'data-book-indicator-index',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":true,"enName":"data Indicator","editModules":false,"title":"数据指标","fullScreen":false,"target":false}',
              open: null
            },
            {
              meun: '',
              code: '',
              hidden: 1,
              rootId: 1225,
              icon: '',
              remark: '',
              type: 1,
              title: '数据指标详情',
              local: '',
              path: '/data-book/data-indicator/details/:id/:name',
              urls: '',
              children: [],
              enName: 'data Indicator',
              id: 1268,
              redirect: '',
              level: 3,
              openPath: '',
              active: '',
              label: '数据指标详情',
              sort: 1,
              parentId: 1182,
              effectiveStatus: true,
              parentName: '',
              component: 'dataBook/indicator/details',
              meta: {
                keepAlive: false,
                allowClick: true,
                roles: [],
                enName: 'data Indicator',
                icon: '',
                editModules: false,
                title: '数据指标详情',
                fullScreen: false,
                target: false,
                effectiveStatus: true
              },
              name: 'data-book-indicator-details',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":true,"enName":"data Indicator","editModules":false,"title":"数据指标详情","fullScreen":false,"target":false}',
              open: null
            }
          ],
          enName: 'data Indicator',
          id: 1182,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '数据指标',
          sort: 30,
          parentId: 1225,
          effectiveStatus: true,
          parentName: 'dataBook',
          component: '',
          meta: {
            allowClick: true,
            roles: [],
            enName: 'data Indicator',
            icon: '',
            title: '数据指标',
            target: false,
            effectiveStatus: true
          },
          name: 'data-book-indicator',
          style: '',
          alwaysShow: 0,
          metastr: '{"allowClick":true,"enName":"data Indicator","title":"数据指标","target":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 1225,
          icon: '',
          remark: '',
          type: 0,
          title: '数据标准',
          local: '',
          path: '/data-book/data-standard',
          urls: '',
          children: [
            {
              meun: '',
              code: '',
              hidden: 1,
              rootId: 1225,
              icon: '',
              remark: '',
              type: 1,
              title: '数据标准',
              local: '',
              path: '/data-book/data-standard',
              urls: '',
              children: [],
              enName: 'data Indicator',
              id: 1269,
              redirect: '',
              level: 3,
              openPath: '',
              active: '',
              label: '数据标准',
              sort: 1,
              parentId: 1202,
              effectiveStatus: true,
              parentName: '',
              component: 'dataBook/dataStandard',
              meta: {
                keepAlive: false,
                allowClick: true,
                roles: [],
                enName: 'data Indicator',
                icon: '',
                editModules: false,
                title: '数据标准',
                fullScreen: false,
                target: false,
                effectiveStatus: true
              },
              name: 'data-book-standard-index',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":true,"enName":"data Indicator","editModules":false,"title":"数据标准","fullScreen":false,"target":false}',
              open: null
            },
            {
              meun: '',
              code: '',
              hidden: 1,
              rootId: 1225,
              icon: '',
              remark: '',
              type: 1,
              title: '数据标准详情',
              local: '',
              path: '/data-book/data-standard/details/:id/:name',
              urls: '',
              children: [],
              enName: 'data Indicator',
              id: 1270,
              redirect: '',
              level: 3,
              openPath: '',
              active: '',
              label: '数据标准详情',
              sort: 10,
              parentId: 1202,
              effectiveStatus: true,
              parentName: '',
              component: 'dataBook/dataStandard/details',
              meta: {
                keepAlive: false,
                allowClick: true,
                roles: [],
                enName: 'data Indicator',
                icon: '',
                editModules: false,
                title: '数据标准详情',
                fullScreen: false,
                target: false,
                effectiveStatus: true
              },
              name: 'data-book-standard-details',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":true,"enName":"data Indicator","editModules":false,"title":"数据标准详情","fullScreen":false,"target":false}',
              open: null
            }
          ],
          enName: 'data Indicator',
          id: 1202,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '数据标准',
          sort: 35,
          parentId: 1225,
          effectiveStatus: true,
          parentName: '',
          component: '',
          meta: {
            allowClick: true,
            roles: [],
            enName: 'data Indicator',
            icon: '',
            title: '数据标准',
            target: false,
            effectiveStatus: true
          },
          name: 'data-book-standard',
          style: '',
          alwaysShow: 0,
          metastr: '{"allowClick":true,"enName":"data Indicator","title":"数据标准","target":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 2001,
          icon: '',
          remark: '',
          type: 0,
          title: '数据流程',
          local: '',
          path: '/data-book/data-process',
          urls: '',
          children: [
            {
              meun: '',
              code: '',
              hidden: 1,
              rootId: 2002,
              icon: '',
              remark: '',
              type: 1,
              title: '数据流程',
              local: '',
              path: '/data-book/data-process',
              urls: '',
              children: [],
              enName: 'data process',
              id: 1269,
              redirect: '',
              level: 3,
              openPath: '',
              active: '',
              label: '数据流程',
              sort: 1,
              parentId: 2001,
              effectiveStatus: true,
              parentName: '',
              component: 'dataBook/dataProcess',
              meta: {
                keepAlive: false,
                allowClick: true,
                roles: [],
                enName: 'data process',
                icon: '',
                editModules: false,
                title: '数据流程',
                fullScreen: false,
                target: false,
                effectiveStatus: true
              },
              name: 'data-book-process-index',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":true,"enName":"data Indicator","editModules":false,"title":"数据标准","fullScreen":false,"target":false}',
              open: null
            },
            {
              meun: '',
              code: '',
              hidden: 1,
              rootId: 1225,
              icon: '',
              remark: '',
              type: 1,
              title: '数据流程详情',
              local: '',
              path: '/data-book/data-process/details/:id/:name',
              urls: '',
              children: [],
              enName: 'data process',
              id: 1270,
              redirect: '',
              level: 3,
              openPath: '',
              active: '',
              label: '数据流程详情',
              sort: 10,
              parentId: 2001,
              effectiveStatus: true,
              parentName: '',
              component: 'dataBook/dataProcess/details',
              meta: {
                keepAlive: false,
                allowClick: true,
                roles: [],
                enName: 'data process',
                icon: '',
                editModules: false,
                title: '数据流程详情',
                fullScreen: false,
                target: false,
                effectiveStatus: true
              },
              name: 'data-book-process-details',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":true,"enName":"data Indicator","editModules":false,"title":"数据标准详情","fullScreen":false,"target":false}',
              open: null
            }
          ],
          enName: 'data process',
          id: 1202,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '数据流程',
          sort: 35,
          parentId: 1225,
          effectiveStatus: true,
          parentName: '',
          component: '',
          meta: {
            allowClick: true,
            roles: [],
            enName: 'data process',
            icon: '',
            title: '数据流程',
            target: false,
            effectiveStatus: true
          },
          name: 'data-book-process',
          style: '',
          alwaysShow: 0,
          metastr: '{"allowClick":true,"enName":"data Indicator","title":"数据标准","target":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 1225,
          icon: '',
          remark: '',
          type: 1,
          title: '数据标签',
          local: '',
          path: '/data-book/data-label',
          urls: '',
          children: [
            {
              meun: '',
              code: '',
              hidden: 1,
              rootId: 1225,
              icon: '',
              remark: '',
              type: 1,
              title: '数据标签',
              local: '',
              path: '/data-book/data-label',
              urls: '',
              children: [],
              enName: 'data Label',
              id: 1271,
              redirect: '',
              level: 3,
              openPath: '',
              active: '',
              label: '数据标签',
              sort: 1,
              parentId: 1218,
              effectiveStatus: true,
              parentName: '',
              component: 'dataBook/dataLabel',
              meta: {
                keepAlive: false,
                allowClick: true,
                roles: [],
                enName: 'data Label',
                icon: '',
                editModules: false,
                title: '数据标签',
                fullScreen: false,
                target: false,
                effectiveStatus: true
              },
              name: 'data-book-label-index',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":true,"enName":"data Label","editModules":false,"title":"数据标签","fullScreen":false,"target":false}',
              open: null
            },
            {
              meun: '',
              code: '',
              hidden: 1,
              rootId: 1225,
              icon: '',
              remark: '',
              type: 1,
              title: '数据标签详情',
              local: '',
              path: '/data-book/data-label/details/:id/:name',
              urls: '',
              children: [],
              enName: 'data Label',
              id: 1272,
              redirect: '',
              level: 3,
              openPath: '',
              active: '',
              label: '数据标签详情',
              sort: 1,
              parentId: 1218,
              effectiveStatus: true,
              parentName: '',
              component: 'dataBook/dataLabel/details',
              meta: {
                keepAlive: false,
                allowClick: true,
                roles: [],
                enName: 'data Label',
                icon: '',
                editModules: false,
                title: '数据标签详情',
                fullScreen: false,
                target: false,
                effectiveStatus: true
              },
              name: 'data-book-label-details',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":true,"enName":"data Label","editModules":false,"title":"数据标签详情","fullScreen":false,"target":false}',
              open: null
            }
          ],
          enName: 'data Label',
          id: 1218,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '数据标签',
          sort: 40,
          parentId: 1225,
          effectiveStatus: true,
          parentName: '',
          component: '',
          meta: {
            keepAlive: false,
            allowClick: true,
            roles: [],
            enName: 'data Label',
            icon: '',
            editModules: false,
            title: '数据标签',
            fullScreen: false,
            target: false,
            effectiveStatus: true
          },
          name: 'data-book-label',
          style: '',
          alwaysShow: 0,
          metastr: '{"keepAlive":false,"allowClick":true,"enName":"data Label","editModules":false,"title":"数据标签","fullScreen":false,"target":false}',
          open: null
        },
        {
          meun: '',
          code: '',
          hidden: 0,
          rootId: 1225,
          icon: '',
          remark: '',
          type: 0,
          title: '业务域',
          local: '',
          path: '/data-book/business-domain',
          urls: '',
          children: [
            {
              meun: '',
              code: '',
              hidden: 1,
              rootId: 1225,
              icon: '',
              remark: '',
              type: 1,
              title: '业务域',
              local: '',
              path: '/data-book/business-domain',
              urls: '',
              children: [],
              enName: 'Business Domain',
              id: 1286,
              redirect: '',
              level: 3,
              openPath: '',
              active: '',
              label: '业务域',
              sort: 0,
              parentId: 1285,
              effectiveStatus: true,
              parentName: '',
              component: 'dataBook/businessDomain',
              meta: {
                keepAlive: false,
                allowClick: true,
                roles: [],
                enName: 'Business Domain',
                icon: '',
                editModules: false,
                title: '业务域',
                fullScreen: false,
                target: false,
                effectiveStatus: true
              },
              name: 'data-book-business-domain-index',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":true,"enName":"Business Domain","editModules":false,"title":"业务域","fullScreen":false,"target":false}',
              open: null
            },
            {
              meun: '',
              code: '',
              hidden: 1,
              rootId: 1225,
              icon: '',
              remark: '',
              type: 1,
              title: '业务域详情',
              local: '',
              path: '/data-book/business-domain/details/:id/:name',
              urls: '',
              children: [],
              enName: 'Business Domain',
              id: 1287,
              redirect: '',
              level: 3,
              openPath: '',
              active: '',
              label: '业务域详情',
              sort: 10,
              parentId: 1285,
              effectiveStatus: true,
              parentName: '',
              component: 'dataBook/businessDomain/details',
              meta: {
                keepAlive: false,
                allowClick: true,
                roles: [],
                enName: 'Business Domain',
                icon: '',
                editModules: false,
                title: '业务域详情',
                fullScreen: false,
                target: false,
                effectiveStatus: true
              },
              name: 'data-book-business-domain-details',
              style: '',
              alwaysShow: 0,
              metastr: '{"keepAlive":false,"allowClick":true,"enName":"Business Domain","editModules":false,"title":"业务域详情","fullScreen":false,"target":false}',
              open: null
            }
          ],
          enName: 'Business Domain',
          id: 1285,
          redirect: '',
          level: 2,
          openPath: '',
          active: '',
          label: '业务域',
          sort: 60,
          parentId: 1225,
          effectiveStatus: true,
          parentName: '',
          component: '',
          meta: {
            allowClick: true,
            roles: [],
            enName: 'Business Domain',
            icon: '',
            title: '业务域',
            target: false,
            effectiveStatus: true
          },
          name: 'data-book-business-domain',
          style: '',
          alwaysShow: 0,
          metastr: '{"allowClick":true,"enName":"Business Domain","title":"业务域","target":false}',
          open: null
        }
      ],
      enName: 'data book',
      id: 1225,
      redirect: '',
      level: 1,
      openPath: '',
      active: '',
      label: '数据目录',
      sort: 49,
      parentId: 0,
      effectiveStatus: true,
      parentName: '',
      component: 'Layout',
      meta: {
        allowClick: false,
        roles: [],
        enName: 'data book',
        icon: 'mdi-book-open-outline',
        title: '数据目录',
        target: false,
        effectiveStatus: true
      },
      name: 'data-book',
      style: '',
      alwaysShow: 0,
      metastr: '{"allowClick":false,"enName":"data book","title":"数据目录","target":false}',
      open: null
    },
    {
      hidden: 0,
      rootId: 0,
      icon: 'mdi-robot-outline',
      type: 0,
      path: '/model',
      children: [
        {
          hidden: 1,
          icon: '',
          type: 1,
          title: '模型',
          path: '/model',
          children: [],
          enName: 'model',
          redirect: '',
          active: '',
          label: '模型',
          sort: 0,
          component: 'modelManage',
          meta: {
            roles: [],
            enName: 'model',
            icon: '',
            title: '模型',
            fullScreen: false
          },
          name: 'index',
          alwaysShow: 0
        }
      ],
      enName: 'model',
      redirect: '',
      active: '',
      sort: 0,
      component: 'Layout',
      meta: {
        allowClick: false,
        roles: [],
        enName: 'model',
        icon: 'mdi-robot-outline',
        title: '模型',
        target: false,
        effectiveStatus: true
      },
      name: 'model',
      alwaysShow: 0
    }
  ],
  permission: [
    'systemManage:roleManage:create',
    'systemManage:roleManage:edit',
    'systemManage:roleManage:delete',
    'systemManage:roleManage:data'
  ]
}
